import os
from config import top_dir, arch_regexp, rep_dirs, rep_links, rep_name

#dirs=("SRPMS","i386/RPMS","i386/base","i486/RPMS","i486/base","i586/RPMS","i586/base","i686/RPMS","i686/base","athlon/RPMS","athlon/base","noarch/RPMS","noarch/base")

class class_arch:
    " -  i386/i486/i586/i686/athlon/noarch"
    def __init__(self,top_dir,arch):
	"      "

	assert top_dir, "top_dir  ."
	assert arch, "  ."
	assert os.path.isdir(top_dir), "  %s   %s   ." % (top_dir,arch)

	#  
	self.top_dir=top_dir
	self.arch=arch
	
	os.mkdir(os.path.join(top_dir,arch),0755)
	os.mkdir(os.path.join(top_dir,arch,"RPMS"),0755)
	os.mkdir(os.path.join(top_dir,arch,"base"),0755)
	os.symlink(os.path.join(top_dir,arch,"RPMS"),os.path.join(top_dir,arch,"RPMS.%s" % rep_name))
	
    def create_item(self,item):
	"      "
	os.symlink(os.path.abspath(item),os.path.join(self.top_dir,self.arch,"RPMS",os.path.basename(item)))
	
    def clean(self):
	"   ()    ,  genbasedir"
	try:
	    os.rmdir(os.path.join(self.top_dir,self.arch,"RPMS")) 
	    os.remove(os.path.join(self.top_dir,self.arch,"RPMS.%s" % rep_name))
	except:
	    print "    . :)"
	    return False
#if not os.path.exists(os.path.join(self.top_dir,self.arch,"RPMS")):
        os.system("rm -f %s" % os.path.join(self.top_dir,self.arch,"base","pkglist.%s*" % rep_name))
	return True
	
    def genbasedir(self):

	"    "
	os.system("genbasedir --topdir %s %s %s" % (self.top_dir,self.arch,rep_name))
	
	    


class class_src:
    " -  src.rpm"
    def __init__(self,top_dir):
	"      src.rpm"

	assert top_dir, "top_dir  ."
	assert os.path.isdir(top_dir), "  %s   %s   ." % top_dir

	#  
	self.top_dir=top_dir
	
	os.mkdir(os.path.join(top_dir,"SRPMS"),0755)
	os.symlink(os.path.join(top_dir,"SRPMS"),os.path.join(top_dir,"SRPMS.%s" % rep_name))
	
    def create_item(self,item):
	"   src "
	os.symlink(os.path.abspath(item),os.path.join(self.top_dir,"SRPMS",os.path.basename(item)))
	
    def clean(self):
	"   ()    ,  genbasedir"
	try:
	    os.rmdir(os.path.join(self.top_dir,"SRPMS")) 
	    os.remove(os.path.join(self.top_dir,"SRPMS.%s" % rep_name))
	except:
	    print "    src.rpm . :)"
	    return False

#if not os.path.exists(os.path.join(self.top_dir,"SRPMS")):
        os.system("find %s -name srclist.%s*  -exec rm -f {} ';'" % (self.top_dir,rep_name))
	return True
	
    def genbasedir(self):
	"    class_arch"
	print " genbasedir   src"
    

class class_repository:
    def __init__(self,prefix):
	self.prefix=prefix
	self.top_dir=os.path.join(top_dir,prefix)
	self.arch_list={"src":None,"nosrc":None,"i386":None,"i486":None,"i586":None,"i686":None,"athlon":None,"noarch":None}
	
	#
	assert prefix, "    "
	assert top_dir, " top_dir   "
	assert os.path.isdir(top_dir), "  %s      ." % top_dir
	
	if os.path.exists(self.top_dir):
	    os.system("rm -rf %s" % self.top_dir)
	os.mkdir(self.top_dir)	        

	self.arch_list["src"]	= class_src(self.top_dir)
	self.arch_list["nosrc"]	= self.arch_list["src"]
	self.arch_list["i386"]	= class_arch(self.top_dir,"i386")
	self.arch_list["i486"]	= class_arch(self.top_dir,"i486")
	self.arch_list["i586"]	= class_arch(self.top_dir,"i586")
	self.arch_list["i686"]	= class_arch(self.top_dir,"i686")
	self.arch_list["athlon"]= class_arch(self.top_dir,"athlon")
	self.arch_list["noarch"]= class_arch(self.top_dir,"noarch")
	
		
    def create_item(self,item):
    
	match=arch_regexp.match(item)
	assert match, "  .  xxx.arch.rpm,   %s" % item

	arch=self.arch_list.get(match.group(1),None)
	assert arch, "  %s" % match.group(1)
	
	arch.create_item(item)

    def clean(self):
	"      "
	for i in self.arch_list.keys():
	    self.arch_list[i].clean()
	
    def genbasedirs(self):
	for i in self.arch_list.keys():
	    self.arch_list[i].clean()
	    self.arch_list[i].genbasedir()
    
